function [new_info_bits parity] = encode_75_recursive_function(info_bits)
%takes in K information bits
%outputs (K+2) info bits (original info bits + 2 terminating bits), and
%(K+2) parity bits

K = length(info_bits);
new_info_bits = info_bits;

%encode
yk_1=0;
yk_2=0;
for k = 1:K
    yk = rem(info_bits(k) + yk_1 + yk_2,2);   %new state
    parity(k) = rem(yk+yk_2,2);             %new parity bik
    yk_2=yk_1;                          %update state
    yk_1=yk;
end;

%termination
if ((yk_1==0)&(yk_2==0))
    new_info_bits(K+1:K+2)=[0 0];
    parity(K+1:K+2)=[0 0];
end;
if ((yk_1==0)&(yk_2==1))
    new_info_bits(K+1:K+2)=[1 0];
    parity(K+1:K+2)=[1 0];
end;
if ((yk_1==1)&(yk_2==0))
    new_info_bits(K+1:K+2)=[1 1];
    parity(K+1:K+2)=[0 1];
end;
if ((yk_1==1)&(yk_2==1))
    new_info_bits(K+1:K+2)=[0 1];
    parity(K+1:K+2)=[1 1];
end;
