clear;

K = 1000;                  %# of info bits

EbN0_db = 0;
EbN0 = 10^(EbN0_db/10);        %convert to linear units
Eb = 2* EbN0;               %because N_0 = 2  (different from Viterbi!!)
sigma_squared = 1;
Es = Eb/2;                 %because R=1/2, i.e., half info bit per symbol

%generate K random bits
pure_bits = round(rand(1,K));

%encode bits
[info_bits parity] = encode_75_recursive_function(pure_bits);

%define RX signal: codeword plus noise
y_info =  sqrt(Es) * (-2*info_bits + 1) + randn(1,K+2);     %noise variance =sigma^2=1  ->  N_0 = 2
y_parity = sqrt(Es) * (-2*parity + 1) + randn(1,K+2);  %noise variance =sigma^2=1  ->  N_0 = 2
%combine into single vector y (odd bits are info bits, even are parity)
y(2*(1:(K+2))-1)=y_info;
y(2*(1:(K+2)))=y_parity;

% call BCJR function to compute LLR's
LLR = rate_half_75_recursive_bcjr_function(y_info, y_parity, zeros(1,K+2), K, Es)

%compute LLR's using brute force method
brute = bcjr_bruteforce_75_recursive(y,K, Es, sigma_squared)